﻿bin/sh

WORK_DIR=$(cd $(dirname $0); pwd)
# WORK_DIR=/opt/software/sof
SOFTWARE_DIR=/opt/software
QTAPP=${WORK_DIR}/miniLCD
RUNPARA=" -qws"

# USB_DIR=$1

# motor init
if [ -e ${WORK_DIR}/motor_init ]; then
 	${WORK_DIR}/motor_init
fi

# stop
/etc/init.d/S50telnet  stop

LOG=/tmp/run.log

# echo "" > $LOG
# echo "WORK_DIR: ${WORK_DIR}"
# echo "SOFTWARE_DIR:${SOFTWARE_DIR}"
# echo "USB_DIR: ${USB_DIR}"

# find max dir
cd  ${SOFTWARE_DIR}
NEW_APP_DIR=`ls -vd [0-9].[0-9]*.[0-9]* | tail -n 1`
OLD_APP_DIR=`ls -vd [0-9].[0-9]*.[0-9]* | tail -n 2 | head  -n 1`
ISUPDATE=0
if [ -d ${SOFTWARE_DIR}/${NEW_APP_DIR} ] && \
    [ -d ${SOFTWARE_DIR}/${OLD_APP_DIR} ] && \
    [ ${SOFTWARE_DIR}/${OLD_APP_DIR} !=  ${SOFTWARE_DIR}/${NEW_APP_DIR} ]; then
    # NEW_APP_DIR=${SOFTWARE_DIR}/${NEW_APP_DIR}
    # OLD_APP_DIR=${SOFTWARE_DIR}/${OLD_APP_DIR}
    echo "NEW_APP_DIR:${NEW_APP_DIR}"
    echo "OLD_APP_DIR:${OLD_APP_DIR}"
    ISUPDATE=1
else
    echo "miss OLD_APP_DIR"  >> $LOG
    # NEW_APP_DIR=" "
    # NEW_APP_DIR=${NEW_APP_DIR}
    OLD_APP_DIR="NULL"
fi

# plug
#if [ -e ${SOFTWARE_DIR}/sof/plug-in/plug-in.sh ]; then
#     ${WORK_DIR}/software/sof/plug-in/plug-in.sh
#     rm  -rf ${SOFTWARE_DIR}/sof/plug-in
#fi


# install fonts
FONTS_PACKAGE=/opt/library/lib/fonts.zip
if [ -e ${FONTS_PACKAGE} ]; then
    echo "install fonts"
    rm -rf /tmp/*.ttf
    unzip ${FONTS_PACKAGE} -d /tmp
fi

# load env
DIR_TMP=${WORK_DIR}
. ${WORK_DIR}/load_env.sh ${USB_DIR}
WORK_DIR=${DIR_TMP}

#OEM update
# packages=`find ${USB_DIR}/OEM/ -name "*-software-*.tar.xz"`
# echo "find packages:"
# echo "${packages}"
# if [ -n "${packages}" ]; then
#     PACKAGE_DIR=/tmp/package-tmp
#     for package in $packages; do
#         if [ -f ${package} ]; then
#           echo "------load: ${package}"
#           #get infomation
#           package_name=${package##*/}
#           part1=${package_name%-*}
#           version=${part1##*-}
#           rm -rf ${PACKAGE_DIR}/*
#           mkdir -p ${PACKAGE_DIR}
#           cp -f ${package} ${PACKAGE_DIR}
#           sync
#           break
#         fi
#     done
#   package=${PACKAGE_DIR}/${package_name}
#   SOFTWARE1_DIR=/opt/software1
#   SOFTWARE2_DIR=/opt/software2
#   echo "------update------"
# #  cat ${WORK_DIR}/image/update_start.bmp  >> /dev/fb0
#   sleep 1
#   echo "package=${package}"
#   echo "version=${version}"
#   mkdir -p ${SOFTWARE1_DIR}/temp
#   rm -f ${package%.*};sync
#   unxz ${package}
#   tar -xf ${package%.*}  -C ${SOFTWARE1_DIR}/temp
#   cd ${SOFTWARE1_DIR}/temp
#   md5sum -c md5sum.list
#   ret=$?
#   if [ 0 != $ret ] ;then
#       echo "OEM software package md5 check failed"
#       RUNPARA=" -qws RELEASE OEM_fail "
#       rm  -rf ${SOFTWARE1_DIR}/temp
#   else
#       echo "check success"
#       rm -rf ${SOFTWARE1_DIR}/sof
#       mv ${SOFTWARE1_DIR}/${NEW_APP_DIR} ${SOFTWARE1_DIR}/0.0.0;sync
#       mv ${SOFTWARE1_DIR}/temp ${SOFTWARE1_DIR}/${version};sync
#       ln -sf ${SOFTWARE1_DIR}/${version} ${SOFTWARE1_DIR}/sof
#       # cp to software2
#       cp -rf ${SOFTWARE1_DIR}/${version}/*  ${SOFTWARE2_DIR}/;sync
# #      cat ${WORK_DIR}/image/update_end.bmp  >> /dev/fb0
#       sleep 2
#   fi
#   sync
# fi

#network                                                                       
ifconfig eth0 up

wifi8188ko=/opt/kernel/ker/8188eu.ko
if [ -e ${wifi8188ko} ]; then
	insmod ${wifi8188ko}
	ifconfig wlan0 up 
fi

#debug
 echo "1" > /proc/sys/kernel/core_uses_pid
 echo "/data/var/core-%e-%p-%t" > /proc/sys/kernel/core_pattern

if [ -e ${USB_DIR} ]; then                            
    umount ${USB_DIR}                           
fi 

# running app
if [ -f ${QTAPP} ] ;then
     echo "*****running app******"
     killall  ipcsystem
     ${WORK_DIR}/ipcsystem &
     chmod  111  ${QTAPP}
     ${QTAPP}${RUNPARA}&
     sleep 5;
fi


# count=`ps -ef |grep ${QTAPP} |grep -v "grep" |wc -l`
count=`ps |grep ${QTAPP} |grep -v "grep" |wc -l`
if [ 0 == $count ] && [ 1 == $ISUPDATE ];then
    echo "*******${QTAPP}  not start *********"
    cd ${SOFTWARE_DIR}
    rm -rf sof
    rm -rf ${NEW_APP_DIR};sync
    ln -sf ${OLD_APP_DIR} sof
    sync
    if [ -f ${QTAPP} ] ;then
        chmod  111  ${QTAPP}
        ${QTAPP} -qws RELEASE upgrade_fail &
    fi
else
    echo "******${QTAPP} start success*******"
    if [ -d ${SOFTWARE_DIR}/${OLD_APP_DIR} ]; then
        echo "rm old app"
        rm -rf ${SOFTWARE_DIR}/${OLD_APP_DIR}
    fi
fi

